package data

import (
	"actatempus_backend/internal/domain/entities"
	"context"

	E "github.com/IBM/fp-go/either"
)

// ProjectDataSource defines the operations for interacting with project data.
type ProjectDataSource interface {
	Create(ctx context.Context, project entities.ProjectCreate) E.Either[error,entities.Project]
	FindByID(ctx context.Context, id string) E.Either[error,entities.Project]
	FindByUserID(ctx context.Context, userID string) E.Either[error,[]entities.Project]
	Update(ctx context.Context, project entities.ProjectUpdate) E.Either[error,entities.Project]
	Delete(ctx context.Context, id string) E.Either[error,entities.Project]
	FindAll(ctx context.Context) E.Either[error,[]entities.Project]
}
